﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Editors.Primitives;
using Infragistics.Windows;
using Infragistics.Windows.Editors;

namespace CurrencyInputCarretPositionChangedEvent
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            
        }

        private void XamCurrencyInput_Loaded(object sender, RoutedEventArgs e)
        {
            MaskedInputTextBox textBox = Utilities.GetDescendantFromName(sender as DependencyObject, "PART_InputTextBox") as MaskedInputTextBox;
            if (textBox != null)
            {
                textBox.SelectionChanged += textBox_SelectionChanged;
            }
        }

        void textBox_SelectionChanged(object sender, RoutedEventArgs e)
        {
            Debug.WriteLine("textBox_SelectionChanged");
        }

        private void XamCurrencyEditorEx_CaretPositionChanged(object sender, EventArgs e)
        {

        }
    }

    public class XamCurrencyEditorEx : XamCurrencyEditor
    {
        protected override void OnPropertyChanged(DependencyPropertyChangedEventArgs e)
        {
            if (e.Property.Name.Equals("CaretPosition"))
            {
                CaretPositionChanged(this, new EventArgs());
            }
            base.OnPropertyChanged(e);
        }

        public event CaretPositionChangedEventHandler CaretPositionChanged;
    }

    public delegate void CaretPositionChangedEventHandler(object sender, EventArgs e);
}
